/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001 TF <tf@denpa.org>
 * All rights reserverd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: $
 */
#ifndef __INCLUDE_XLADDER_H
#define __INCLUDE_XLADDER_H

#ifndef True
#define True 1
#endif

#ifndef False
#define False 0
#endif

/* 
 * ܤԤ
 */
#define WAIT_TIME 40000

/* 
 * ֽ
 */
#define ARC_SCN 0
#define ARC_BMP 1
#define ARC_WAV 2
#define ARC_ERR 3

#define FNAME_LEN 16

/* 
 * 
 */
#define ARG_LEN 64
#define ARG_NUM 7

#define FLAG_LEN 16

/* 
 * κĿ
 */
#define ALT_NUM 2

/* 
 * ץȽѥХåեΥ
 */
#define SCR_BUF_LEN 1024

/* 
 * ƥɽط
 */
#define TEXT_WIDTH 32
#define TEXT_HEIGHT 20

#define BACKLOG_LEN 48

/* 
 * 
 */
#define STAT_STACK_LEN 16

#define STAT_EMPTY 0
#define STAT_TEXT 1
#define STAT_COMMAND 2
#define STAT_WAIT 3
#define STAT_DIALOG 4
#define STAT_DICT 5
#define STAT_BACKLOG 6

#define DEBUG

#ifdef DEBUG
#define dprintf(a) fprintf a
#else
#define dprintf(a)
#endif

#include <stdio.h>
#include <sys/types.h>

typedef struct {
    char name[FNAME_LEN];
    int pos;
    int width;
    int height;
    int osize;
    int esize;
} ArchiveItem;

typedef struct {
    FILE *fp;
    int num;
    int type;
    ArchiveItem *item;
} Archive;


typedef struct _SceneList {
    u_char name[ARG_LEN];
    int offset;
    struct _SceneList *next;
} SceneList;

typedef struct _FlagList {
    u_char value[FLAG_LEN];
    struct _SceneList *next;
} FlagList;

typedef struct {
    struct {
	u_char *data;
	int cur_pos;
	int end_pos;
	SceneList *scene_list;
    } script;

    struct {
	u_char string[ARG_LEN];
	u_char label[ARG_LEN];
    } alternative[ALT_NUM];
    int alternative_num;

    FlagList *flag;
    FlagList *cg_flag;

    struct {
	int tvram[TEXT_WIDTH][TEXT_HEIGHT];
	int x;
	int y;
    } text;

    struct {
	int tvram[TEXT_WIDTH][BACKLOG_LEN];
	int y;
	int loop;
    } text_history;

    struct {
	int per_char;
	int per_sentence;
	int per_page;
    } wait;

    int state_stack_depth;
    int state_stack[STAT_STACK_LEN];

    Archive *cg_arc;
    Archive *script_arc;
    Archive *sound_arc;
} XLCore;

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

EXTERN XLCore xlCore;

u_char *get_text(Archive *arc, const char *name);
Archive *open_archive(char *filename);
void close_archive(Archive *arc);

void load_script(const char *name);
void free_script(void);

void add_flag(const char *flag, FlagList ** flist);
void clear_flag(FlagList ** flist);

int parse_arg(const char *cmd, char argv[ARG_NUM][ARG_LEN]);

/* file.c */
void save_persistent_info();
void load_persistent_info();
void save_game();
void load_game();

#endif
